


/********************************************************************************
**                                                                       		*
**     X25 Incoming call processor definitions							 		*
**                                                                       		*
**------------------------------------------------------------------------------*
**                                                                       		*
**               Copyright Apple Computer, Inc. 1987-90                  		*
**                         All Rights Reserved                           		*
**                     Apple Need to Know Confidential                   		*
**                                                                       		*
**------------------------------------------------------------------------------*
**                                                                       		*
**  Revision History: 1.0d1 	- Status and SubStatus1 codes moved to       	*
**                            	  X25Server.h                                	* 
**                    1.0.1d4	- 10.31.90 JEC									*
**								  Added facility codes for Closed User Group    *
**								  with Outgoing Access                          *
**                                                                       		*
**                                                                       		*
********************************************************************************/


	/* codes for Listen Agent Mapping			*/


	/* primary match groups						*/
	
#define LA_CallingNSAP				1			/* Calling NSAP address					*/
#define LA_CalledNSAP				2			/* Called NSAP address					*/
#define LA_DTE_CalledSubAddr		3			/* Called DTE sub address				*/
#define LA_DTE_CallingAddr			4			/* Calling DTE address					*/
#define	LA_CallUserData				5			/* Call user data field					*/

	/* secondary modifiers to the match group	*/
	
#define LA_ClosedUserGroup			6			/* Closed User Group					*/
#define	LA_AcceptReverseCharging	7			/* Reverse Charging						*/
#define	LA_AcceptFastSelect			8			/* Fast Select Call						*/
#define LA_BilateralClosedUser		9			/* Bilateral Closed User Group			*/

#define NumberofSelectors			9			/* Number of Selectors					*/


					/* x25 Facility Codes			*/

#define FL_One_Octet				0<<6		/* facility length of one octet			*/
#define FL_Two_Octets				1<<6		/* facility length of two octets		*/
#define FL_Three_Octets				2<<6		/* facility length of three octets		*/
#define FL_More_Octets				3<<6		/* facility length of more than three	*/

#define REVERSE_AND_FAST			0x01		/* reverse charging/fast select code	*/
#define RC_BITPATTERN				1<<0		/* Reverse Charging Requested Bit		*/
#define FS_BITPATTERN				1<<7		/* Fast Select Requested Bit			*/

#define REGULAR_CUG					0x03		/* Regular CUG Facility Code			*/
#define EXTENDED_CUG				0x47		/* Extended CUG Facility Code			*/
#define Bilateral_CUG				0x41		/* Bilateral CUG Facility Code			*/
#define REGULAR_CUGOA				0x09		/* Regular CUG with Outgoing Access Facility Code	*/
#define EXTENDED_CUGOA				0x48		/* Extended CUG with Outgoing Access Facility Code	*/


#define CCITT_DTE_FACILITIES		0x0F		/* CCITT Facility Marker				*/
#define CALLING_NSAPCode			0xCB		/* Calling NSAP Facility Code			*/
#define CALLED_NSAPCode				0xC9		/* Called NSAP Facility Code			*/

#define FacilityMarker				0			/* facility field marker value			*/

					/* Facility indicator for ListenAgent		*/
					
#define REGFacilities				0			/* parsing normal facilites field data	*/
#define CCITTFacilities				1			/* in CCITT facility marker options		*/
#define	ForeignFacilities			2			/* in Foreign facility marker options	*/

					/* Error Codes for cause field when Listener Agent Rejects the Call */
					
#define LAE_NotObtainable			0x8c		/* Error - Not Obtainable (generic error)	*/
#define LAE_NoReverseSub			0x99		/* Error - Reserve Charging Not Subscribed	*/
#define LAE_NoFastSelSub			0xa9		/* Error - Fast Select Not Subscribed		*/

